﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO.Ports;
using System.Threading;
using System.IO;
using System.Diagnostics;
using System.Globalization;

namespace EM_SERIES_Config_Software
{
    public partial class Form1 : Form
    {
        public const int WM_NCLBUTTONDOWN = 0xA1;
        public const int HT_CAPTION = 0x2;

        [System.Runtime.InteropServices.DllImportAttribute("user32.dll")]
        public static extern int SendMessage(IntPtr hWnd, int Msg, int wParam, int lParam);
        [System.Runtime.InteropServices.DllImportAttribute("user32.dll")]
        public static extern bool ReleaseCapture();
        CultureInfo ci = new CultureInfo("en-us");

        private static modbus mb = new modbus();
        private static short[] mbReadValues;
        private short mbNumber = 25;
        private static bool _connected = false;
        private static bool _deviceisset = true;
        private static bool _mbissent = false;
        private static bool _mbisread = false;
        bool Succeed = false;
        delegate void delegate_ShowDeviceRegister(short[] value);
        delegate void delegate_updateUI();
        bool input_change = false;
        bool pvgain_change = false;
        bool pvadj_change = false;
        bool pvfil_change = false;
        bool cf_change = false;
        bool slh_change = false;
        bool sll_change = false;
        bool out1inv_change = false;
        bool out1inh_change = false;
        bool out1inl_change = false;
        bool out1adj_change = false;
        bool out2inv_change = false;
        bool out2inh_change = false;
        bool out2inl_change = false;
        bool out2adj_change = false;
        bool baudrate_change = false;
        bool commu_change = false;
        bool slaveid_change = false;
        bool per10Enable_change = false;
        bool out1Status_change = false;
        bool out2Status_change = false;


        Decimal pvgain_min = 0.80M;
        Decimal pvgain_max = 1.20M;
        Decimal pvadj_min = -200.0M;
        Decimal pvadj_max = 200.0M;
        Decimal pvfil_min = 0M;
        Decimal pvfil_max = 32M;
        Decimal sll_min;
        Decimal sll_max;
        Decimal slh_min;
        Decimal slh_max;
        Decimal out1_min;
        Decimal out1_max;
        Decimal out2_min;
        Decimal out2_max;
        Decimal outAdj_min = -2.00M;
        Decimal outAdj_max = 2.00M;
        Decimal slaveid_min = 1;
        Decimal slaveid_max = 255;

        short typeSelect;
        short modelSelect;
        Byte pv1;
        Byte pv2;
        Byte pv3;
        Byte pv4;
        Byte[] pvByte;
        Int32 pvValue;
        Int16 out1Value;
        Int16 out2Value;
        Int16 cojValue;

        short inputSelect;
        short pvGainSelect;
        short pvAdjSelect;
        short pvFilSelect;
        short cfSelect;
        int slhSelect;
        int sllSelect;
        short out1StatusSelect;
        short out1InvSelect;
        int out1HighLimitselect;
        int out1LowLimitselect;
        int out1AdjSelect;
        short out2StatusSelect;
        short out2InvSelect;
        int out2HighLimitselect;
        int out2LowLimitselect;
        int out2AdjSelect;
        short swVer;
        short setDefaultSelect;
        short typeOptionSelect;
        short output1TypeSelect;
        short output2TypeSelect;
        short baudRateSelect;
        short dataSizeSelect;
        short stopBitSelect;
        short paritySelect;
        short commuSelect;
        short slaveIdSelect;
        short per10EnableSelect;

        object[] selectedPara = new object[26];

        string[] emNLTypeText = new string[] { "A", "B", "C", "D", "E", "G" };
        string[] emLCTypeText = new string[] { "A1", "A2", "A3", "A4", "E1", "G1" };
        enum emNTypeOpt { A, B, C, D, E, G};
        enum emLCTypeOpt { A1, A2, A3, A4, E1, G1};
        enum degree {c,f };
        enum model { N, LC, L };
        enum outputPolarity { non_inv, inv};
        enum outputType { none, AN0_10VDC, AN4_20mA, RS485};
        enum emNMbReg { pv, out1, out2, inputType, out1Type, out2Type, sll, slh, out1Inv, out1Inl, out1Inh
                , out1Adj, out2Inv, out2Inl, out2Inh, out2Adj, pvFil, pvGain, pvAdj, coj, cf,typeOpt,
            buadRate, commu, slaveId, per10_enable, setDefault
        };
        enum emLCMbReg { pv_1, pv_2, out1, out2, inputType, coj, pvGain, pvAdj, pvFil, cf, slh, sll
                ,out1Status, out1Inv, out1Inh, out1Inl, out1Adj, out2Status, out2Inv, out2Inh, out2Inl, out2Adj
                , per10_enable, swver, setDefault, typeOpt = 265};
        enum type { TCK, TCJ, TCR, TCT, TCN, TCS, TCE, PT100, AN0_20mA, AN4_20mA, AN0_100mA, AN0_75mV, AN0_150mV
                , AN0_1VDC, AN0_10VDC, AN0_500VDC, AN0_500VAC, AN0_5AAC, AN0_100R, AN0_1kR, AN0_10kR, AN0_100kR};
        private decimal _decimalp;
        enum commu { b8n1, b8n2, b8o1, b8o2, b8e1, b8e2};
        decimal[,] InputLimitMin = new decimal[,] 
        {
            { -200, -328},
            { -200, -328},
            { -50, -58},
            { -200, -328},
            { -200, -328},
            { -50, -58},
            { -200, -328},
            { -200, -328},
            { 0,0 },
            { 4,4 },
            { 0,0 },
            { 0,0 },
            { 0,0 },
            { 0,0 },
            { 0,0 },
            { 0,0 },
            { 0,0 },
            { 0,0 },
            { 0,0 },
            { 0,0 },
            { 0.010M,0.010M },
            { 0.01M,0.01M }
        };
        decimal[,] InputLimitMax = new decimal[,]
        {
            { 1372.0M, 2501.6M},
            { 1200.0M, 2192.0M},
            { 1680.0M, 3056.0M},
            { 400.0M, 752.0M},
            { 1300.0M, 2372.0M},
            { 1768.0M, 3214.4M},
            { 1000.0M, 1832.0M},
            { 680.0M, 1256.0M},
            { 20.0M, 20.0M },
            { 20.0M, 20.0M },
            { 100.0M, 100.0M },
            { 75.0M, 75.0M },
            { 150.0M, 150.0M },
            { 1.0M, 1.0M },
            { 10.0M, 10.0M },
            { 500.0M, 500.0M },
            { 500.0M, 500.0M },
            { 5.0M, 5.0M },
            { 100.0M, 100.0M },
            { 1000.0M, 1000.0M },
            { 10.0M, 10.0M },
            { 100.0M, 100.0M }
        };
        decimal[,] PVDecimalPoint = new decimal[,]
        {
            { 0.1M, 1, 10.0M},
            { 0.1M, 1, 10.0M},
            { 0.1M, 1, 10.0M},
            { 0.1M, 1, 10.0M},
            { 0.1M, 1, 10.0M},
            { 0.1M, 1, 10.0M},
            { 0.1M, 1, 10.0M},
            { 0.1M, 1, 10.0M},
            { 0.001M, 3, 1000.0M},
            { 0.001M, 3, 1000.0M},
            { 0.01M, 2, 100.0M},
            { 0.01M, 2, 100.0M},
            { 0.01M, 2, 100.0M},
            { 0.0001M, 4, 10000.0M},
            { 0.001M, 3, 1000.0M},
            { 0.1M, 1, 10.0M},
            { 0.1M, 1, 10.0M},
            { 0.001M, 3, 1000.0M},
            { 0.01M, 2, 100.0M},
            { 0.1M, 1, 10.0M},
            { 0.001M, 3, 1000.0M},
            { 0.01M, 2, 100.0M}
        };


        public Form1()
        {
            InitializeComponent();
            DisbleDeviceInfoPanel();
            DisableSetttingPanel();
        }

        #region All Form controls
        private void MakeFrmMovable(MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                ReleaseCapture();
                SendMessage(Handle, WM_NCLBUTTONDOWN, HT_CAPTION, 0);
            }
        }

        private void Form1_MouseDown(object sender, MouseEventArgs e)
        {
            MakeFrmMovable(e);
        }

        private void panel3_MouseDown(object sender, MouseEventArgs e)
        {
            MakeFrmMovable(e);
        }

        private void menu2Panel_MouseDown(object sender, MouseEventArgs e)
        {
            MakeFrmMovable(e);
        }

        private void panel1_MouseDown(object sender, MouseEventArgs e)
        {
            MakeFrmMovable(e);
        }
        #endregion

        #region minimize,restore,close window form
        private void closeBtn_Click(object sender, EventArgs e)
        {
            if (MyMsgBox.Showmsg("Are you sure you want to exit this software?", "Exit!", MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.Yes)
            {
                _mbissent = true;
                Thread.Sleep(1000);
                if (_connected) { mb.Close(); }                
                DisableEvent();
                Thread.Sleep(200);
                Application.ExitThread(); //kill thread
                Environment.Exit(1); //kill background process
                Application.Exit();
            }
        }

        private void minimizeBtn_Click(object sender, EventArgs e)
        {
            if (WindowState == FormWindowState.Normal)
            {
                WindowState = FormWindowState.Maximized;
            }
            else if (WindowState == FormWindowState.Maximized)
            {
                WindowState = FormWindowState.Normal;
            }

        }

        private void button3_Click(object sender, EventArgs e)
        {
            WindowState = FormWindowState.Minimized;
        }

        #endregion

        #region Initialized, Enable, Disable Panel
        private void DisbleDeviceInfoPanel()
        {
            modelPicBox.Visible = false;
            deviceModelLabel.Text = "";
            deviceSubModelLabel.Text = "";
        }

        private void EnableDeviceInfoPanel(string model, string subModel)
        {
            modelPicBox.Visible = true;
            deviceModelLabel.Text = "Model : " + model;
            deviceSubModelLabel.Text = "SubModel : " + subModel;
        }

        private void EnableSetttingPanel()
        {
            pvShowPanel.BackColor = Color.FromArgb(71, 203, 101);
            outputPanel.BackColor = Color.FromArgb(71, 203, 101); ;
            applyBtn.Enabled = true;
            applyBtn.BackColor = Color.FromArgb(242, 97, 68);
            setDefaultBtn.Enabled = true;
            loadBtn.Enabled = true;
            saveBtn.Enabled = true;
            inputSettingPanel.Enabled = true;
            out1CurrentSrcPanel.Enabled = true;
            out2CurrentSrcPanel.Enabled = true;
            out1Rs485Panel.Enabled = true;
        }

        private void DisableSetttingPanel()
        {
            pvShowPanel.BackColor = Color.LightGray;
            outputPanel.BackColor = Color.LightGray;
            pvLabel.Text = "";
            pvdegreeLabel.Text = "";
            cojLabel.Text = "";
            cojdegreeLabel.Text = "";
            out1ValueLabel.Text = "";
            out1UnitLabel.Text = "";
            out2ValueLabel.Text = "";
            out2UnitLabel.Text = "";
            applyBtn.Enabled = false;
            applyBtn.BackColor = Color.DarkGray;
            setDefaultBtn.Enabled = false;
            loadBtn.Enabled = false;
            saveBtn.Enabled = false;
            inputSettingPanel.Enabled = false;
            out1CurrentSrcPanel.Enabled = false;
            out2CurrentSrcPanel.Enabled = false;
            out1Rs485Panel.Enabled = false;
            out1StatusButton.Visible = false;
            out2StatusButton.Visible = false;
        }


        private void Initial_SettingPanel(short _model)
        {
            inputTypeComboBox.Items.Clear();
            output1TypeComBox.Enabled = false;
            output2TypeComBox.Enabled = false;

            output1TypeComBox.Items.AddRange(new object[] { "None", "0-10VDC", "4-20mA" });
            output2TypeComBox.Items.AddRange(new object[] { "None", "0-10VDC", "4-20mA", "RS-485" });

            output1TypeComBox.SelectedIndex = output1TypeSelect;
            output2TypeComBox.SelectedIndex = output2TypeSelect;

            switch (_model)
            {
                case (short)model.N:
                case (short)model.L:
                    switch (typeOptionSelect)
                    {
                        case (short)emNTypeOpt.A:
                            inputTypeComboBox.Items.AddRange(new object[] { "TC-K", "TC-J", "TC-R", "TC-T", "TC-N",
                            "TC-S", "TC-E", "PT100", "0-20 mA", "4-20 mA", "0-100 mA", "0-75 mV", "0-150 mV", "0-1 VDC", "0-10 VDC" });
                            break;
                        case (short)emNTypeOpt.B:
                            inputTypeComboBox.Items.AddRange(new object[] { "0-500 VDC" });
                            break;
                        case (short)emNTypeOpt.C:
                            inputTypeComboBox.Items.AddRange(new object[] { "0-500 VAC" });
                            break;
                        case (short)emNTypeOpt.D:
                            inputTypeComboBox.Items.AddRange(new object[] { "0-5 A.AC" });
                            break;
                        case (short)emNTypeOpt.E:
                            inputTypeComboBox.Items.AddRange(new object[] { "0-100 Ω", "0-1 kΩ" });
                            break;
                        case (short)emNTypeOpt.G:
                            inputTypeComboBox.Items.AddRange(new object[] { "0.01-10 kΩ", "0.01-100 kΩ" });
                            break;
                        default:
                            break;                      
                    }

                    switch (output1TypeSelect)
                    {
                        default:
                        case (short)outputType.none:
                            out1CurrentSrcPanel.Enabled = false;
                            break;
                        case (short)outputType.AN0_10VDC:
                            out1AdjUnit.Text = "VDC";
                            break;
                        case (short)outputType.AN4_20mA:
                            out1AdjUnit.Text = "mA";
                            break;
                    }
                    switch (output2TypeSelect)
                    {
                        default:
                        case (short)outputType.none:
                            out2CurrentSrcPanel.Enabled = false;
                            break;
                        case (short)outputType.AN0_10VDC:
                            out2AdjUnit.Text = "VDC";
                            break;
                        case (short)outputType.AN4_20mA:
                            out2AdjUnit.Text = "mA";
                            break;
                        case (short)outputType.RS485:
                            break;
                    }
                    if (_model == (short)model.N) { out1Rs485Panel.Enabled = true; }
                    baudRateComboBox.Items.Clear();
                    baudRateComboBox.Items.AddRange(new object[] { 4800, 9600, 19200, 38400, 57600 });
                    dataSizeComboBox.Items.Clear();
                    dataSizeComboBox.Items.AddRange(new object[] { 8, 9 });
                    parityBitComboBox.Items.Clear();
                    parityBitComboBox.Items.AddRange(new object[] { "None", "Odd", "Even" });
                    stopBotComboBox.Items.Clear();
                    stopBotComboBox.Items.AddRange(new object[] { 1, 2 });
                    break;
                case (short)model.LC:
                    switch (typeOptionSelect)
                    {
                        case (short)emLCTypeOpt.A1:
                            inputTypeComboBox.Items.AddRange(new object[] { "TC-K", "TC-J", "TC-R", "TC-T", "TC-N",
                    "TC-S", "TC-E", "PT100" });
                            break;
                        case (short)emLCTypeOpt.A2:
                            inputTypeComboBox.Items.AddRange(new object[] { "0-20 mA", "4-20 mA", "0-100 mA" });
                            break;
                        case (short)emLCTypeOpt.A3:
                            inputTypeComboBox.Items.AddRange(new object[] { "0-75 mV", "0-150 mV", "0-1 VDC" });
                            break;
                        case (short)emLCTypeOpt.A4:
                            inputTypeComboBox.Items.AddRange(new object[] { "0-10 VDC" });
                            break;
                        case (short)emLCTypeOpt.E1:
                            inputTypeComboBox.Items.AddRange(new object[] { "0-100 Ω", "0-1 kΩ" });
                            break;
                        case (short)emLCTypeOpt.G1:
                            inputTypeComboBox.Items.AddRange(new object[] { "0-10 kΩ", "0-100 kΩ" });
                            break;
                        default:
                            break;
                    }
                    output1TypeComBox.SelectedIndex = 2;
                    output2TypeComBox.SelectedIndex = 2;
                    out1Rs485Panel.Enabled = false;
                    out1StatusButton.Visible = true;
                    out2StatusButton.Visible = true;
                    EnableOutput(out1StatusButton, out1ValuePanel, out1CurrentSrcPanel,  out1StatusSelect);
                    EnableOutput(out2StatusButton, out2ValuePanel, out2CurrentSrcPanel,  out2StatusSelect);
                    break;
            }

            UpdateInputDecimalPoint(PVDecimalPoint[inputSelect, 0], (int)PVDecimalPoint[inputSelect, 1]);

            out1LowLimitNumUpDown.Increment = 0.01M;
            out1LowLimitNumUpDown.DecimalPlaces = 2;
            out1HighLimitNumUpDown.Increment = 0.01M;
            out1HighLimitNumUpDown.DecimalPlaces = 2;
            out2LowLimitNumUpDown.Increment = 0.01M;
            out2LowLimitNumUpDown.DecimalPlaces = 2;
            out2HighLimitNumUpDown.Increment = 0.01M;
            out2HighLimitNumUpDown.DecimalPlaces = 2;
            out1AdjNumUpDown.Increment = 0.01M;
            out1AdjNumUpDown.DecimalPlaces = 2;
            out2AdjNumUpDown.Increment = 0.01M;
            out2AdjNumUpDown.DecimalPlaces = 2;
        }

        private void EnableOutput(Button outputChannel, Panel outputPanel, Panel outputSettingPanel, short status)
        {
            switch (status)
            {
                case 0:
                    outputChannel.BackColor = Color.DarkRed;
                    //outputChannel.Text = "OFF";
                    outputPanel.Visible= false;
                    outputSettingPanel.Enabled = false;
                    break;
                case 1:
                    outputChannel.BackColor = Color.LimeGreen;
                    //outputChannel.Text = "ON";
                    outputPanel.Visible = true;
                    outputSettingPanel.Enabled = true;
                    break;
                default:
                    break;
            }
        }

        #endregion

        public static bool connected
        {
            get { return _connected; }
        }
        public static bool deviceisset
        {
            get { return _deviceisset; }
        }
        public bool mbissent
        {
            get { return _mbissent; }
        }
        public bool mbisread
        {
            get { return _mbisread; }
        }

        void Get_SerialPort()
        {
            deviceComPortComboBox.Items.Clear();
            String[] devicePort = SerialPort.GetPortNames();
            deviceComPortComboBox.Items.AddRange(devicePort);
        }

        #region Click -->> Connect, Disconnect
        private void connectBtn_Click(object sender, EventArgs e)
        {
            switch (connectBtn.Text)
            {
                case "Connect":
                    if (mb.Open(deviceComPortComboBox.Text, 9600, 8, Parity.None, StopBits.One))
                    {
                        try
                        {
                            connectBtn.Text = "Disconnect";
                            _connected = true;
                            deviceComPortComboBox.Enabled = false;
                            EnableSetttingPanel();
                            DisableEvent();
                            mbReadValues = new short[1];
                            selectDeviceLabel.Visible = false;
                            mb.SendFc4(1, 0x3000, 1, ref mbReadValues);
                            modelSelect = mbReadValues[0];                  
                            switch (modelSelect)
                            {
                                case (short)model.N:
                                    modelPicBox.Image = Properties.Resources.EM_xN_Icon;
                                    mbNumber = 27;
                                    break;
                                case (short)model.LC:
                                    modelPicBox.Image = Properties.Resources.EM_xLC_Icon;
                                    mbNumber = 25;
                                    break;
                                case (short)model.L:
                                    modelPicBox.Image = Properties.Resources.EM_xLC_Icon;
                                    mbNumber = 27;
                                    break;
                            }
                            mbReadValues = new short[mbNumber];
                            mb.SendFc4(1, 0, mbNumber, ref mbReadValues);
                            SetAllParameters(mbReadValues);
                            switch (modelSelect)
                            {
                                case (short)model.N:
                                    EnableDeviceInfoPanel("EM-N", emNLTypeText[typeOptionSelect]);
                                    break;
                                case (short)model.LC:
                                    var value = new short[1]; 
                                    mb.SendFc4(1, (ushort)emLCMbReg.typeOpt, 1, ref value);
                                    typeOptionSelect = value[0];
                                    EnableDeviceInfoPanel("EM-LC", emLCTypeText[typeOptionSelect]);
                                    break;
                                case (short)model.L:
                                    EnableDeviceInfoPanel("EM-L", emNLTypeText[typeOptionSelect]);
                                    break;
                            }
                            ShowPVOutputParameter(mbReadValues);
                            Initial_SettingPanel(modelSelect);
                            ShowSettingParameter();
                            applyBtn.Enabled = false;
                            Thread readDeviceThread = new Thread(new ThreadStart(ReadDeviceThread));
                            readDeviceThread.Start();
                            EnableEvent();
                        }
                        catch
                        {
                            MyMsgBox.Showmsg("please disconnect device and select again", "Wrong selected model", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        }
                    }
                    else
                    {
                        MyMsgBox.Showmsg("Failed to connect device due to this issue \r\n - Com port is not availble\r\n" +
                            " - Device is not powered up", "Communication failed", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                    break;
                case "Disconnect":
                    deviceComPortComboBox.Enabled = true;
                    connectBtn.Text = "Connect";
                    _connected = false;
                    DisbleDeviceInfoPanel();
                    Thread.Sleep(1000);
                    if (mb.Close())
                    {
                        DisableSetttingPanel();
                    }
                    else
                    {
                        MyMsgBox.Showmsg("Can not disconnect, device might be unplugged", "Communication failed", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    }
                    break;
            }
        }

        #endregion

        private void UpdateInputDecimalPoint(decimal increment, int decimalplace)
        {
            pvAdjNumUpDown.Increment = increment;
            pvAdjNumUpDown.DecimalPlaces = decimalplace;
            scaleLowNumUpDown.Increment = increment;
            scaleLowNumUpDown.DecimalPlaces = decimalplace;
            scaleHighNumUpDown.Increment = increment;
            scaleHighNumUpDown.DecimalPlaces = decimalplace;
        }

        public void ReadDeviceThread()
        {
            while (connected)
            {
                if (!mbissent)
                {
                    Thread.Sleep(500);
                    mb.SendFc4(1, 0, mbNumber, ref mbReadValues);
                    if (connected) { BeginInvoke(new delegate_ShowDeviceRegister(ShowPVOutputParameter), new object[] { mbReadValues }); }
                }
            }
        }

        private void SetAllParameters(short[] values)
        {
            switch (modelSelect)
            {
                case (short)model.N:
                case (short)model.L:
                    pvValue = values[0];
                    out1Value = values[1];
                    out2Value = values[2];
                    inputSelect = values[3];
                    output1TypeSelect = values[4];
                    output2TypeSelect = values[5];
                    sllSelect = values[6];
                    slhSelect = values[7];
                    out1InvSelect = values[8];
                    out1LowLimitselect = values[9];
                    out1HighLimitselect = values[10];
                    out1AdjSelect = values[11];
                    out2InvSelect = values[12];
                    out2LowLimitselect = values[13];
                    out2HighLimitselect = values[14];
                    out2AdjSelect = values[15];
                    pvFilSelect = values[16];
                    pvGainSelect = values[17];
                    pvAdjSelect = values[18];
                    cojValue = values[19];
                    cfSelect = values[20];
                    typeOptionSelect = values[21];
                    baudRateSelect = values[22];
                    commuSelect = values[23];
                    slaveIdSelect = values[24];
                    per10EnableSelect = values[25];
                    setDefaultSelect = values[26];
                    break;
                case (short)model.LC:
                    //convert short pv to byte then reverse
                    pv1 = (byte)((values[0] & 0xFF00) >> 8);
                    pv2 = (byte)(values[0] & 0xFF);
                    pv3 = (byte)((values[1] & 0xFF00) >> 8);
                    pv4 = (byte)(values[1] & 0xFF);
                    pvByte = BitConverter.GetBytes((pv1 << 24) + (pv2 << 16) + (pv3 << 8) + pv4);
                    if (BitConverter.IsLittleEndian)
                        Array.Reverse(pvByte);

                    pvValue = BitConverter.ToInt32(pvByte, 0);
                    out1Value = values[2];
                    out2Value = values[3];
                    inputSelect = values[4];
                    cojValue = values[5];
                    pvGainSelect = values[6];
                    pvAdjSelect = values[7];
                    pvFilSelect = values[8];
                    cfSelect = values[9];
                    slhSelect = values[10];
                    sllSelect = values[11];
                    out1StatusSelect = values[12];
                    out1InvSelect = values[13];
                    out1HighLimitselect = values[14];
                    out1LowLimitselect = values[15];
                    out1AdjSelect = values[16];
                    out2StatusSelect = values[17];
                    out2InvSelect = values[18];
                    out2HighLimitselect = values[19];
                    out2LowLimitselect = values[20];
                    out2AdjSelect = values[21];
                    per10EnableSelect = values[22];
                    swVer = values[23];
                    setDefaultSelect = values[24];
                    break;
            }
            _decimalp = PVDecimalPoint[inputSelect, 2];
        }

        private void ShowPVOutputParameter(short[] values)
        {
            short input = 0;
            short output1Type;
            short output2Type;
            short cf = 0;
            int sll = 0, slh = 0;

            switch (modelSelect)
            {
                case (short)model.N:
                case (short)model.L:
                    pvValue = values[0];
                    out1Value = values[1];
                    out2Value = values[2];
                    input = values[3];
                    output1Type = values[4];
                    output2Type = values[5];
                    cf = values[20];
                    sll = values[6];
                    slh = values[7];
                    out1ValueLabel.Text = (out1Value / 100.0).ToString("0.00");
                    out2ValueLabel.Text = (out2Value / 100.0).ToString("0.00");
                    switch (output1Type)
                    {
                        case (short)outputType.none:
                            out1ValueLabel.Visible = false;
                            break;
                        case (short)outputType.AN0_10VDC:
                            out1ValueLabel.Visible = true;
                            out1UnitLabel.Text = "Vdc";
                            break;
                        case (short)outputType.AN4_20mA:
                            out1ValueLabel.Visible = true;
                              out1UnitLabel.Text = "mA";
                            break;
                    }
                    switch (output2Type)
                    {
                        case (short)outputType.none:
                            out2ValueLabel.Visible = false;
                            break;
                        case (short)outputType.AN0_10VDC:
                            out2ValueLabel.Visible = true;
                            out2UnitLabel.Text = "Vdc";
                            break;
                        case (short)outputType.AN4_20mA:
                            out2ValueLabel.Visible = true;
                            out2UnitLabel.Text = "mA";
                            break;
                    }
                    break;
                case (short)model.LC:
                    //convert short pv to byte then reverse
                    pv1 = (byte)((values[0] & 0xFF00) >> 8);
                    pv2 = (byte)(values[0] & 0xFF);
                    pv3 = (byte)((values[1] & 0xFF00) >> 8);
                    pv4 = (byte)(values[1] & 0xFF);
                    pvByte = BitConverter.GetBytes((pv1 << 24) + (pv2 << 16) + (pv3 << 8) + pv4);
                    if (BitConverter.IsLittleEndian)
                        Array.Reverse(pvByte);

                    pvValue = BitConverter.ToInt32(pvByte, 0);
                    out1Value = values[2];
                    out2Value = values[3];
                    input = values[4];
                    cf = values[9];
                    slh = values[10];
                    sll = values[11];

                    out1ValueLabel.Text = (out1Value / 100.0).ToString("0.00");
                    out2ValueLabel.Text = (out2Value / 100.0).ToString("0.00");



                    out1UnitLabel.Text = "mA";
                    out2UnitLabel.Text = "mA";
                    break;
            }
            //put recieve data into components
            if(per10EnableSelect == 1)
            {
                int dif;
                dif = slh - sll;
                sll = sll - ((dif * 10)/100);
                slh = slh + ((dif * 10) / 100);
            }
      
            if (pvValue < sll_min * _decimalp || pvValue> sll_max * _decimalp)
            {
                this.pvLabel.Text = "----";
            }
            else
            {
                this.pvLabel.Text = (pvValue).ToString("0");
                this.pvLabel.Text = ((pvValue) / _decimalp).ToString("F0" + PVDecimalPoint[inputSelect,1].ToString(), ci);
            }

            if ((pvValue < sll && pvValue >= sll_min * _decimalp) || (pvValue > slh && pvValue <= sll_max * _decimalp))
            {
                this.pvLabel.ForeColor = Color.Tomato;
            }
            else
            {
                this.pvLabel.ForeColor = Color.White;
            }

            cojdegreeLabel.Text = "";
            cojLabel.Text = "";
            switch (input)
            {
                case (short)type.TCK:
                case (short)type.TCJ:
                case (short)type.TCR:
                case (short)type.TCT:
                case (short)type.TCN:
                case (short)type.TCS:
                case (short)type.TCE:
                case (short)type.PT100:                    
                    switch (cf)
                    {
                        case (short)degree.c:
                            pvdegreeLabel.Text = "°C";
                            break;
                        case (short)degree.f:
                            pvdegreeLabel.Text = "°F";
                            break;
                    }
                    if (input != (short)type.PT100) {
                        cojLabel.Text = (cojValue / _decimalp).ToString("0.0");
                        cojdegreeLabel.Text = pvdegreeLabel.Text; } 
                    break;                 
                case (short)type.AN0_20mA:
                case (short)type.AN4_20mA:
                case (short)type.AN0_100mA:
                    pvdegreeLabel.Text = "mA";
                    break;
                case (short)type.AN0_75mV:
                case (short)type.AN0_150mV:
                    pvdegreeLabel.Text = "mV";
                    break;
                case (short)type.AN0_1VDC:
                case (short)type.AN0_10VDC:
                    pvdegreeLabel.Text = "V";
                    break;
                case (short)type.AN0_500VDC:
                    pvdegreeLabel.Text = "Vdc";
                    break;
                case (short)type.AN0_500VAC:
                    pvdegreeLabel.Text = "Vac";
                    break;
                case (short)type.AN0_5AAC:
                    pvdegreeLabel.Text = "Aac";
                    break;
                case (short)type.AN0_100R:
                case (short)type.AN0_1kR:
                    pvdegreeLabel.Text = "Ω";
                    break;
                case (short)type.AN0_10kR:
                case (short)type.AN0_100kR:
                    pvdegreeLabel.Text = "kΩ";
                    break;
                default:
                    break;
            }
        }

        private void ShowSettingParameter()
        {
            switch (modelSelect)
            {
                case (short)model.N:
                case (short)model.L:
                    switch (typeOptionSelect)
                    {
                        case (short)emNTypeOpt.A:
                            inputTypeComboBox.SelectedIndex = (int)inputSelect;
                            break;
                        case (short)emNTypeOpt.B:
                            inputTypeComboBox.SelectedIndex = (int)inputSelect - 15;
                            break;
                        case (short)emNTypeOpt.C:
                            inputTypeComboBox.SelectedIndex = (int)inputSelect - 16;
                            break;
                        case (short)emNTypeOpt.D:
                            inputTypeComboBox.SelectedIndex = (int)inputSelect - 17;
                            break;
                        case (short)emNTypeOpt.E:
                            inputTypeComboBox.SelectedIndex = (int)inputSelect - 18;
                            break;
                        case (short)emNTypeOpt.G:
                            inputTypeComboBox.SelectedIndex = (int)inputSelect - 20;
                            break;
                    }                
                    break;
                case (short)model.LC:
                    switch(typeOptionSelect)
                    {
                        case (short)emLCTypeOpt.A1:
                            inputTypeComboBox.SelectedIndex = (int)inputSelect;
                            break;
                        case (short)emLCTypeOpt.A2:
                            inputTypeComboBox.SelectedIndex = (int)inputSelect -8 ;
                            break;
                        case (short)emLCTypeOpt.A3:
                            inputTypeComboBox.SelectedIndex = (int)inputSelect - 11;
                            break;
                        case (short)emLCTypeOpt.A4:
                            inputTypeComboBox.SelectedIndex = (int)inputSelect - 14;
                            break;
                        case (short)emLCTypeOpt.E1:
                            inputTypeComboBox.SelectedIndex = (int)inputSelect - 18;
                            break;
                        case (short)emLCTypeOpt.G1:
                            inputTypeComboBox.SelectedIndex = (int)inputSelect - 20;
                            break;
                    }
                    break;
                default:
                    break;
            }

            Select_input_unit();
            if(inputSelect >= (short)type.TCK && inputSelect <= (short)type.PT100)
            {
                cfPanel.Enabled = true;
            }
            else
            {
                cfPanel.Enabled = false;
            }
            switch (cfSelect)
            {
                case (short)degree.c:
                    degreeCRadioBtn.Checked = true;
                    break;
                case (short)degree.f:
                    degreeFRadioBtn.Checked = true;
                    break;
            }
            pvFilterNumUpDown.Value = pvFilSelect;
            pvGainNumUpDown.Value = pvGainSelect / 100M;
            pvAdjNumUpDown.Value = pvAdjSelect / _decimalp;
            scaleLowNumUpDown.Value = sllSelect / _decimalp;
            scaleHighNumUpDown.Value = slhSelect / _decimalp;
            Select_output_unit();
            if (modelSelect == (short)model.LC)
            {
                EnableOutput(out1StatusButton, out1ValuePanel, out1CurrentSrcPanel, out1StatusSelect);
                EnableOutput(out2StatusButton, out2ValuePanel, out2CurrentSrcPanel, out2StatusSelect);
            }
            switch (out1InvSelect)
            {
                case (short)outputPolarity.non_inv:
                    out1NonInvRdb.Checked = true;
                    break;
                case (short)outputPolarity.inv:
                    out1InvRdb.Checked = true;
                    break;
            }
            out1LowLimitNumUpDown.Value = out1LowLimitselect / 100M;
            out1HighLimitNumUpDown.Value = out1HighLimitselect / 100M;
            out1AdjNumUpDown.Value = out1AdjSelect / 100M;
            switch (out2InvSelect)
            {
                case (short)outputPolarity.non_inv:
                    out2NonInvRdb.Checked = true;
                    break;
                case (short)outputPolarity.inv:
                    out2InvRdb.Checked = true;
                    break;
            }
            out2LowLimitNumUpDown.Value = out2LowLimitselect / 100M;
            out2HighLimitNumUpDown.Value = out2HighLimitselect / 100M;
            out2AdjNumUpDown.Value = out2AdjSelect / 100M;
            if(modelSelect==(short)model.N || modelSelect==(short)model.L)
            {
                baudRateComboBox.SelectedIndex = (int)baudRateSelect;
                slaveidNumUpDown.Value = slaveIdSelect;
                switch (commuSelect)
                {
                    case (short)commu.b8n1:
                        setRS485Protocol(0, 0, 0);
                        break;
                    case (short)commu.b8n2:
                        setRS485Protocol(0, 1, 0);
                        break;
                    case (short)commu.b8o1:
                        setRS485Protocol(0, 0, 1);
                        break;
                    case (short)commu.b8o2:
                        setRS485Protocol(0, 1, 1);
                        break;
                    case (short)commu.b8e1:
                        setRS485Protocol(0, 0, 2);
                        break;
                    case (short)commu.b8e2:
                        setRS485Protocol(0, 1, 2);
                        break;
                }

            }
            switch(per10EnableSelect)
            {
                case 0:
                    per10CheckBox.Checked = false;
                    break;
                case 1:
                    per10CheckBox.Checked = true;
                    break;
            }

        }

        private void setRS485Protocol(byte dataSize, byte stopBit, byte parity)
        {
            dataSizeComboBox.SelectedIndex = dataSize;
            stopBotComboBox.SelectedIndex = stopBit;
            parityBitComboBox.SelectedIndex = parity;
        }

        private void deviceComPortComboBox_Click(object sender, EventArgs e)
        {
            Get_SerialPort();
        }

        private void inputTypeComboBox_SelectionChangeCommitted(object sender, EventArgs e)
        {           
            inputSelect = (short)inputTypeComboBox.SelectedIndex;
            switch (modelSelect)
            {
                case (short)model.N:
                case (short)model.L:
                    switch (typeOptionSelect)
                    {
                        case (short)emNTypeOpt.A:
                        default:
                            break;
                        case (short)emNTypeOpt.B:
                            inputSelect += 15;
                            break;
                        case (short)emNTypeOpt.C:
                            inputSelect += 16;
                            break;
                        case (short)emNTypeOpt.D:
                            inputSelect += 17;
                            break;
                        case (short)emNTypeOpt.E:
                            inputSelect += 18;
                            break;
                        case (short)emNTypeOpt.G:
                            inputSelect += 20;
                            break;
                    }
                    break;
                case (short)model.LC:
                    switch (typeOptionSelect)
                    {
                        case (short)emLCTypeOpt.A1:
                        default:
                            break;
                        case (short)emLCTypeOpt.A2:
                            inputSelect += 8;
                            break;
                        case (short)emLCTypeOpt.A3:
                            inputSelect += 11;
                            break;
                        case (short)emLCTypeOpt.A4:
                            inputSelect += 14;
                            break;
                        case (short)emLCTypeOpt.E1:
                            inputSelect += 18;
                            break;
                        case (short)emLCTypeOpt.G1:
                            inputSelect += 20;
                            break;
                    }
                    break;
            }
            Select_input_unit();
            UpdateScaleValue();
            input_change = true;
            applyBtn.Enabled = true;
        }

        private void UpdateScaleValue()
        {
            _decimalp = PVDecimalPoint[inputSelect, 2];
            slhSelect = (int)(InputLimitMax[inputSelect, cfSelect] * _decimalp);
            scaleHighNumUpDown.Value = InputLimitMax[inputSelect, cfSelect];
            sllSelect = (int)(InputLimitMin[inputSelect, cfSelect] * _decimalp);
            scaleLowNumUpDown.Value = InputLimitMin[inputSelect, cfSelect];
        }

        private void degreeCRadioBtn_CheckedChanged(object sender, EventArgs e)
        {
            if(degreeCRadioBtn.Checked == true)
            {
                cfSelect = (short)degree.c;
            }
            else
            {
                cfSelect = (short)degree.f;
            }
            Select_input_unit();
            UpdateScaleValue();
            cf_change = true;
            applyBtn.Enabled = true;
        }

        private void pvFilterNumUpDown_ValueChanged(object sender, EventArgs e)
        {
            if (pvFilterNumUpDown.Value >= pvfil_min && pvFilterNumUpDown.Value <= pvfil_max)
            {
                pvFilSelect = (short)pvFilterNumUpDown.Value;
                pvfil_change = true;
                applyBtn.Enabled = true;
            }
            else
            {
                MyMsgBox.Showmsg("Please select 'PV Filter' between " + pvfil_min + " to " + pvfil_max, "Wrong Value!", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                pvFilterNumUpDown.Value = (decimal)pvFilSelect;
            }
        }

        private void pvGainNumUpDown_ValueChanged(object sender, EventArgs e)
        {
            if (pvGainNumUpDown.Value >= pvgain_min && pvGainNumUpDown.Value <= pvgain_max)
            {
                pvGainSelect = (short)(pvGainNumUpDown.Value * 100M);
                pvgain_change = true;
                applyBtn.Enabled = true;
            }
            else
            {
                MyMsgBox.Showmsg("Please select 'PV Gain' between " + pvgain_min + " to " + pvgain_max, "Wrong Value!", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                pvGainNumUpDown.Value = (decimal)(pvGainSelect / 100M);
            }
        }

        private void pvAdjNumUpDown_ValueChanged(object sender, EventArgs e)
        {
            if (pvAdjNumUpDown.Value >= pvadj_min && pvAdjNumUpDown.Value <= pvadj_max)
            {
                pvAdjSelect = (short)(pvAdjNumUpDown.Value * _decimalp);
                pvadj_change = true;
                applyBtn.Enabled = true;
            }
            else
            {
                MyMsgBox.Showmsg("Please select 'PV Adjust' between " + pvadj_min + " to " + pvadj_max, "Wrong Value!", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                pvAdjNumUpDown.Value = (decimal)(pvAdjSelect / _decimalp);
            }
        }

        private void scaleLowNumUpDown_ValueChanged(object sender, EventArgs e)
        {
            if (scaleLowNumUpDown.Value >= sll_min && scaleLowNumUpDown.Value <= sll_max)
            {
                if (scaleLowNumUpDown.Value <= scaleHighNumUpDown.Value)
                {
                    sllSelect = (short)(scaleLowNumUpDown.Value * _decimalp);
                    sll_change = true;
                    applyBtn.Enabled = true;
                }
                else
                {
                    MyMsgBox.Showmsg("Please select 'Scale Low Limit' that is lower than 'Scale High Limit' ", "Wrong Value!", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    scaleLowNumUpDown.Value = (decimal)sllSelect / _decimalp;
                }
            }
            else
            {
                MyMsgBox.Showmsg("Please select 'Scale Low Limit' between      " + sll_min + " to " + sll_max, "Wrong Value!", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                scaleLowNumUpDown.Value = (decimal)sllSelect / _decimalp;
            }
        }

        private void scaleHighNumUpDown_ValueChanged(object sender, EventArgs e)
        {
            if (scaleHighNumUpDown.Value >= slh_min && scaleHighNumUpDown.Value <= slh_max)
            {
                if (scaleHighNumUpDown.Value >= scaleLowNumUpDown.Value)
                {
                    slhSelect = (short)(scaleHighNumUpDown.Value * _decimalp);
                    slh_change = true;
                    applyBtn.Enabled = true;
                }
                else
                {
                    MyMsgBox.Showmsg("Please select 'Scale High Limit' that is higher than 'Scale Low Limit' ", "Wrong Value!", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    scaleHighNumUpDown.Value = (decimal)slhSelect / _decimalp;
                }
            }
            else
            {
                MyMsgBox.Showmsg("Please select 'Scale High Limit' between    " + slh_min + " to " + slh_max, "Wrong Value!", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                scaleHighNumUpDown.Value = (decimal)slhSelect / _decimalp;
            }

        }

        private void out1NonInvRdb_CheckedChanged(object sender, EventArgs e)
        {
            if (out1NonInvRdb.Checked == true)
            {
                out1InvSelect = 0;
            }
            else
            {
                out1InvSelect = 1;
            }
            out1inv_change = true;
            applyBtn.Enabled = true;
        }

        private void out1LowLimitNumUpDown_ValueChanged(object sender, EventArgs e)
        {
            if (out1LowLimitNumUpDown.Value >= out1_min && out1LowLimitNumUpDown.Value <= out1_max)
            {
                if (out1LowLimitNumUpDown.Value <= out1HighLimitNumUpDown.Value)
                {
                    out1LowLimitselect = (short)(out1LowLimitNumUpDown.Value * 100M);
                    out1inl_change = true;
                    applyBtn.Enabled = true;
                }
                else
                {
                    MyMsgBox.Showmsg("Please select 'Output Ch1 Low Limit that is lower than 'Output High Limit'", "Wrong Value!", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    out1LowLimitNumUpDown.Value = (decimal)out1LowLimitselect / 100M;
                }
            }
            else
            {
                MyMsgBox.Showmsg("Please select 'Output Ch1 Low Limit' between     " + out1_min + " to " + out1_max, "Wrong Value!", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                out1LowLimitNumUpDown.Value = (decimal)out1LowLimitselect / 100M;
            }
        }

        private void out1HighLimitNumUpDown_ValueChanged(object sender, EventArgs e)
        {
            if (out1HighLimitNumUpDown.Value >= out1_min && out1HighLimitNumUpDown.Value <= out1_max)
            {
                if (out1HighLimitNumUpDown.Value >= out1LowLimitNumUpDown.Value)
                {
                    out1HighLimitselect = (short)(out1HighLimitNumUpDown.Value * 100M);
                    out1inh_change = true;
                    applyBtn.Enabled = true;
                }
                else
                {
                    MyMsgBox.Showmsg("Please select 'Output Ch1 High Limit that is higher than 'Output Low Limit'", "Wrong Value!", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    out1HighLimitNumUpDown.Value = (decimal)out1HighLimitselect / 100M;
                }
            }
            else
            {
                MyMsgBox.Showmsg("Please select 'Output Ch1 High Limit' between    " + out1_min + " to " + out1_max, "Wrong Value!", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                out1HighLimitNumUpDown.Value = (decimal)out1HighLimitselect / 100M;
            }
        }

        private void out1AdjNumUpDown_ValueChanged(object sender, EventArgs e)
        {
            if (out1AdjNumUpDown.Value >= outAdj_min && out1AdjNumUpDown.Value <= outAdj_max)
            {
                out1AdjSelect = (short)(out1AdjNumUpDown.Value * 100M);
                out1adj_change = true;
                applyBtn.Enabled = true;
            }
            else
            {
                MyMsgBox.Showmsg("Please select 'Output Ch1 Adjust' between    " + outAdj_min + " to " + outAdj_max, "Wrong Value!", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                out1AdjNumUpDown.Value = (decimal)out1AdjSelect / 100M;
            }
        }

        private void out2NonInvRdb_CheckedChanged(object sender, EventArgs e)
        {
            if (out2NonInvRdb.Checked == true)
            {
                out2InvSelect = 0;
            }
            else
            {
                out2InvSelect = 1;
            }
            out2inv_change = true;
            applyBtn.Enabled = true;
        }

        private void out2LowLimitNumUpDown_ValueChanged(object sender, EventArgs e)
        {
            if (out2LowLimitNumUpDown.Value >= out2_min && out2LowLimitNumUpDown.Value <= out2_max)
            {
                if (out2LowLimitNumUpDown.Value <= out2HighLimitNumUpDown.Value)
                {
                    out2LowLimitselect = (short)(out2LowLimitNumUpDown.Value * 100M);
                    out2inl_change = true;
                    applyBtn.Enabled = true;
                }
                else
                {
                    MyMsgBox.Showmsg("Please select 'Output Ch2 Low Limit that is lower than 'Output High Limit'", "Wrong Value!", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    out2LowLimitNumUpDown.Value = (decimal)out2LowLimitselect / 100M;
                }
            }
            else
            {
                MyMsgBox.Showmsg("Please select 'Output Ch2 Low Limit' between     " + out2_min + " to " + out2_max, "Wrong Value!", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                out2LowLimitNumUpDown.Value = (decimal)out2LowLimitselect / 100M;
            }
        }

        private void out2HighLimitNumUpDown_ValueChanged(object sender, EventArgs e)
        {
            if (out2HighLimitNumUpDown.Value >= out2_min && out2HighLimitNumUpDown.Value <= out2_max)
            {
                if (out2HighLimitNumUpDown.Value >= out2LowLimitNumUpDown.Value)
                {
                    out2HighLimitselect = (short)(out2HighLimitNumUpDown.Value * 100M);
                    out2inh_change = true;
                    applyBtn.Enabled = true;
                }
                else
                {
                    MyMsgBox.Showmsg("Please select 'Output Ch2 High Limit that is higher than 'Output Low Limit'", "Wrong Value!", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    out2HighLimitNumUpDown.Value = (decimal)out2HighLimitselect / 100M;
                }
            }
            else
            {
                MyMsgBox.Showmsg("Please select 'Output Ch2 High Limit' between    " + out2_min + " to " + out2_max, "Wrong Value!", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                out2HighLimitNumUpDown.Value = (decimal)out2HighLimitselect / 100M;
            }

        }

        private void out2AdjNumUpDown_ValueChanged(object sender, EventArgs e)
        {
            if (out2AdjNumUpDown.Value >= outAdj_min && out2AdjNumUpDown.Value <= outAdj_max)
            {
                out2AdjSelect = (short)(out2AdjNumUpDown.Value * 100M);
                out2adj_change = true;
                applyBtn.Enabled = true;
            }
            else
            {
                MyMsgBox.Showmsg("Please select 'Output Ch2 Adjust' between    " + outAdj_min + " to " + outAdj_max, "Wrong Value!", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                out2AdjNumUpDown.Value = (decimal)out2AdjSelect / 100M;
            }
        }

        private void slaveidNumUpDown_ValueChanged(object sender, EventArgs e)
        {
            if (slaveidNumUpDown.Value >= slaveid_min && slaveidNumUpDown.Value <= slaveid_max)
            {
                slaveIdSelect = (short)(slaveidNumUpDown.Value);
                slaveid_change = true;
                applyBtn.Enabled = true;
            }
            else
            {
                MyMsgBox.Showmsg("Please select 'Address ID' between    " + slaveid_min + " to " + slaveid_max, "Wrong Value!", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                slaveidNumUpDown.Value = (decimal)slaveIdSelect;
            }
        }

        private void baudRateComboBox_SelectionChangeCommitted(object sender, EventArgs e)
        {
            baudRateSelect = (short)baudRateComboBox.SelectedIndex;
            baudrate_change = true;
            applyBtn.Enabled = true;
        }

        private void dataSizeComboBox_SelectionChangeCommitted(object sender, EventArgs e)
        {
            dataSizeSelect = (short)dataSizeComboBox.SelectedIndex;
            commu_change = true;
            applyBtn.Enabled = true;
        }

        private void stopBotComboBox_SelectionChangeCommitted(object sender, EventArgs e)
        {
            stopBitSelect = (short)stopBotComboBox.SelectedIndex;
            commu_change = true;
            applyBtn.Enabled = true;
        }

        private void parityBitComboBox_SelectionChangeCommitted(object sender, EventArgs e)
        {
            paritySelect = (short)parityBitComboBox.SelectedIndex;
            commu_change = true;
            applyBtn.Enabled = true;
        }

        private void per10CheckBox_CheckedChanged(object sender, EventArgs e)
        {
            switch(per10CheckBox.Checked)
            {
                case false:
                    per10EnableSelect = 0;
                    break;
                case true:
                    per10EnableSelect = 1;
                    break;
            }
            per10Enable_change = true;
            applyBtn.Enabled = true;
        }

        private void Select_input_unit()
        {
            UpdatesettingLimit(InputLimitMin[inputSelect, cfSelect], InputLimitMax[inputSelect, cfSelect]);
            UpdatePVScaleSetting(inputSelect);
        }

        private void Select_output_unit()
        {
            if(modelSelect == (short)model.LC)
            {
                out1_min = 4.00M;
                out1_max = 20.00M;
                out2_min = 4.00M;
                out2_max = 20.00M;
                return;
            }
            switch(output1TypeSelect)
            {
                default:
                case (short)outputType.none:
                    out1_min = 0.0M;
                    out1_max = 0.0M;
                    break;
                case (short)outputType.AN0_10VDC:
                    out1_min = 0.0M;
                    out1_max = 10.0M;
                    break;
                case (short)outputType.AN4_20mA:
                    out1_min = 4.00M;
                    out1_max = 20.00M;
                    break;
            }
            switch (output2TypeSelect)
            {
                default:
                case (short)outputType.none:
                case (short)outputType.RS485:
                    out2_min = 0.0M;
                    out2_max = 0.0M;
                    break;
                case (short)outputType.AN0_10VDC:
                    out2_min = 0.0M;
                    out2_max = 10.0M;
                    break;
                case (short)outputType.AN4_20mA:
                    out2_min = 4.00M;
                    out2_max = 20.00M;
                    break;
            }
        }

        private void UpdatesettingLimit(decimal min, decimal max)
        {
            sll_max = max;
            sll_min = min;
            //sllnumud.Value = min;
            slh_max = max;
            slh_min = min;
            //slhnumud.Value = max;
        }

        private void UpdatePVScaleSetting(short input)
        {
            scaleHighNumUpDown.Increment = PVDecimalPoint[input,0];
            scaleHighNumUpDown.DecimalPlaces = (int)PVDecimalPoint[input, 1];
            scaleLowNumUpDown.Increment = PVDecimalPoint[input, 0];
            scaleLowNumUpDown.DecimalPlaces = (int)PVDecimalPoint[input, 1];
        }

        private void setDefaultBtn_Click(object sender, EventArgs e)
        {
            if (MyMsgBox.Showmsg("Your current configuration might be lost. Are you sure you want to restore defaults?", "Restore Device!", MessageBoxButtons.YesNo, MessageBoxIcon.Warning) == DialogResult.Yes)
            {
                using (MsgBoxWaiting msg = new MsgBoxWaiting(setDefaultProcess))
                {
                    msg.ShowDialog(this);
                }
            }
            EnableEvent();
            if (Succeed)
            {
                MyMsgBox.Showmsg("Restoring device is succeeded", "Done!", MessageBoxButtons.OK, MessageBoxIcon.None);
            }
            else
            {
                MyMsgBox.Showmsg("Can not restore default setting, Please try again", "Fail!", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void setDefaultProcess()
        {
            _mbissent = true;
            Thread.Sleep(1000);
            DisableEvent();
            bool _setDefSucceed = true;
            switch (modelSelect)
            {
                case (short)model.N:
                case (short)model.L:
                    _setDefSucceed = mb.SendFc6(1, (ushort)emNMbReg.setDefault, 0);
                    break;
                case (short)model.LC:
                    _setDefSucceed = mb.SendFc6(1, (ushort)emLCMbReg.setDefault, 0);
                    break;
            }
            Thread.Sleep(2000);
            Succeed = _setDefSucceed;
            BeginInvoke(new delegate_updateUI(updateUI));
        }

        private void applyBtn_Click(object sender, EventArgs e)
        {
            using (MsgBoxWaiting msg = new MsgBoxWaiting(applyProcess))
            {
                msg.ShowDialog(this);
            }
            EnableEvent();
            if (Succeed)
            {
                MyMsgBox.Showmsg("Applying setting is succeeded", "Done!", MessageBoxButtons.OK, MessageBoxIcon.None);
            }
            else
            {
                MyMsgBox.Showmsg("Can not apply setting, Please try again", "Fail", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void applyProcess()
        {
            _mbissent = true;
            Thread.Sleep(1000);
            Succeed = ApplyChange(false);
            BeginInvoke(new delegate_updateUI(updateUI));
        }

        private bool ApplyChange(bool resetall)
        {
            bool _applySucceed = true;
            if (connected)
            {
                switch (modelSelect)
                {
                    case (short)model.N:
                    case (short)model.L:
                        if (input_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emNMbReg.inputType, inputSelect); input_change = false; }
                        if (cf_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emNMbReg.cf, cfSelect); cf_change = false; }
                        if (per10Enable_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emNMbReg.per10_enable, per10EnableSelect); per10Enable_change = false; }
                        if (sll_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emNMbReg.sll, sllSelect); sll_change = false; }
                        if (slh_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emNMbReg.slh, slhSelect); slh_change = false; }
                        if (output1TypeSelect == (short)outputType.AN4_20mA || output1TypeSelect == (short)outputType.AN0_10VDC)
                        {
                            if (out1inv_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emNMbReg.out1Inv, out1InvSelect); out1inv_change = false; }
                            if (out1inl_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emNMbReg.out1Inl, out1LowLimitselect); out1inl_change = false; }
                            if (out1inh_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emNMbReg.out1Inh, out1HighLimitselect); out1inh_change = false; }
                            if (out1adj_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emNMbReg.out1Adj, out1AdjSelect); out1adj_change = false; }
                        }
                        if (output2TypeSelect == (short)outputType.AN4_20mA || output2TypeSelect == (short)outputType.AN0_10VDC)
                        {
                            if (out2inv_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emNMbReg.out2Inv, out2InvSelect); out2inv_change = false; }
                            if (out2inl_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emNMbReg.out2Inl, out2LowLimitselect); out2inl_change = false; }
                            if (out2inh_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emNMbReg.out2Inh, out2HighLimitselect); out2inh_change = false; }
                            if (out2adj_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emNMbReg.out2Adj, out2AdjSelect); out2adj_change = false; }
                        }
                        if (pvfil_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emNMbReg.pvFil, pvFilSelect); pvfil_change = false; }
                        if (pvgain_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emNMbReg.pvGain, pvGainSelect); pvgain_change = false; }
                        if (pvadj_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emNMbReg.pvAdj, pvAdjSelect); pvgain_change = false; }
                        if (baudrate_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emNMbReg.buadRate, baudRateSelect); baudrate_change = false; }
                        if (commu_change || resetall)
                        {
                            if (dataSizeSelect == 0 && stopBitSelect == 0 && paritySelect == 0)
                            {
                                commuSelect = (short)commu.b8n1;
                            }
                            else if (dataSizeSelect == 0 && stopBitSelect == 1 && paritySelect == 0)
                            {
                                commuSelect = (short)commu.b8n2;
                            }
                            else if (dataSizeSelect == 0 && stopBitSelect == 0 && paritySelect == 1)
                            {
                                commuSelect = (short)commu.b8o1;
                            }
                            else if (dataSizeSelect == 0 && stopBitSelect == 1 && paritySelect == 1)
                            {
                                commuSelect = (short)commu.b8o2;
                            }
                            else if (dataSizeSelect == 0 && stopBitSelect == 0 && paritySelect == 2)
                            {
                                commuSelect = (short)commu.b8e1;
                            }
                            else if (dataSizeSelect == 0 && stopBitSelect == 1 && paritySelect == 2)
                            {
                                commuSelect = (short)commu.b8e2;
                            }
                            _applySucceed &= mb.SendFc6(1, (ushort)emNMbReg.commu, commuSelect); commu_change = false;
                        }
                        if (slaveid_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emNMbReg.slaveId, slaveIdSelect); slaveid_change = false; }
                        break;
                    case (short)model.LC:
                        if (input_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emLCMbReg.inputType, inputSelect); input_change = false; }
                        if (pvgain_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emLCMbReg.pvGain, pvGainSelect); pvgain_change = false; }
                        if (pvadj_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emLCMbReg.pvAdj, pvAdjSelect); pvgain_change = false; }
                        if (pvfil_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emLCMbReg.pvFil, pvFilSelect); pvfil_change = false; }
                        if (cf_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emLCMbReg.cf, cfSelect); cf_change = false; }
                        if (per10Enable_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emLCMbReg.per10_enable, per10EnableSelect); per10Enable_change = false; }
                        if (slh_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emLCMbReg.slh, slhSelect); slh_change = false; }
                        if (sll_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emLCMbReg.sll, sllSelect); sll_change = false; }
                        if (out1inv_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emLCMbReg.out1Inv, out1InvSelect); out1inv_change = false; }
                        if (out1inh_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emLCMbReg.out1Inh, out1HighLimitselect); out1inh_change = false; }
                        if (out1inl_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emLCMbReg.out1Inl, out1LowLimitselect); out1inl_change = false; }
                        if (out1adj_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emLCMbReg.out1Adj, out1AdjSelect); out1adj_change = false; }
                        if (out2inv_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emLCMbReg.out2Inv, out2InvSelect); out2inv_change = false; }
                        if (out2inh_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emLCMbReg.out2Inh, out2HighLimitselect); out2inh_change = false; }
                        if (out2inl_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emLCMbReg.out2Inl, out2LowLimitselect); out2inl_change = false; }
                        if (out2adj_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emLCMbReg.out2Adj, out2AdjSelect); out2adj_change = false; }
                        if (out1Status_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emLCMbReg.out1Status, out1StatusSelect); out1Status_change = false; }
                        if (out2Status_change || resetall) { _applySucceed &= mb.SendFc6(1, (ushort)emLCMbReg.out2Status, out2StatusSelect); out2Status_change = false; }
                        break;
                }
            }
            return _applySucceed;
        }

        private void DisableEvent()
        {
            this.inputTypeComboBox.SelectionChangeCommitted -= new EventHandler(inputTypeComboBox_SelectionChangeCommitted);
            this.degreeCRadioBtn.CheckedChanged -= new EventHandler(degreeCRadioBtn_CheckedChanged);
            this.pvFilterNumUpDown.ValueChanged -= new EventHandler(pvFilterNumUpDown_ValueChanged);
            this.pvGainNumUpDown.ValueChanged -= new EventHandler(pvGainNumUpDown_ValueChanged);
            this.pvAdjNumUpDown.ValueChanged -= new EventHandler(pvAdjNumUpDown_ValueChanged);
            this.pvFilterNumUpDown.ValueChanged -= new EventHandler(pvFilterNumUpDown_ValueChanged);
            this.scaleLowNumUpDown.ValueChanged -= new EventHandler(scaleLowNumUpDown_ValueChanged);
            this.scaleHighNumUpDown.ValueChanged -= new EventHandler(scaleHighNumUpDown_ValueChanged);
            this.out1NonInvRdb.CheckedChanged -= new EventHandler(out1NonInvRdb_CheckedChanged);
            this.out1LowLimitNumUpDown.ValueChanged -= new EventHandler(out1LowLimitNumUpDown_ValueChanged);
            this.out1HighLimitNumUpDown.ValueChanged -= new EventHandler(out1HighLimitNumUpDown_ValueChanged);
            this.out1AdjNumUpDown.ValueChanged -= new EventHandler(out1AdjNumUpDown_ValueChanged);
            this.out2NonInvRdb.CheckedChanged -= new EventHandler(out2NonInvRdb_CheckedChanged);
            this.out2LowLimitNumUpDown.ValueChanged -= new EventHandler(out2LowLimitNumUpDown_ValueChanged);
            this.out2HighLimitNumUpDown.ValueChanged -= new EventHandler(out2HighLimitNumUpDown_ValueChanged);
            this.out2AdjNumUpDown.ValueChanged -= new EventHandler(out2AdjNumUpDown_ValueChanged);
            this.slaveidNumUpDown.ValueChanged -= new EventHandler(slaveidNumUpDown_ValueChanged);
            this.baudRateComboBox.SelectionChangeCommitted -= new EventHandler(baudRateComboBox_SelectionChangeCommitted);
            this.stopBotComboBox.SelectionChangeCommitted -= new EventHandler(stopBotComboBox_SelectionChangeCommitted);
            this.dataSizeComboBox.SelectionChangeCommitted -= new EventHandler(dataSizeComboBox_SelectionChangeCommitted);
            this.parityBitComboBox.SelectionChangeCommitted -= new EventHandler(parityBitComboBox_SelectionChangeCommitted);
            this.per10CheckBox.CheckedChanged -= new EventHandler(per10CheckBox_CheckedChanged);
            _mbissent = true;
        }

        private void EnableEvent()
        {
            this.inputTypeComboBox.SelectionChangeCommitted += new EventHandler(inputTypeComboBox_SelectionChangeCommitted);
            this.degreeCRadioBtn.CheckedChanged += new EventHandler(degreeCRadioBtn_CheckedChanged);
            this.pvFilterNumUpDown.ValueChanged += new EventHandler(pvFilterNumUpDown_ValueChanged);
            this.pvGainNumUpDown.ValueChanged += new EventHandler(pvGainNumUpDown_ValueChanged);
            this.pvAdjNumUpDown.ValueChanged += new EventHandler(pvAdjNumUpDown_ValueChanged);
            this.pvFilterNumUpDown.ValueChanged += new EventHandler(pvFilterNumUpDown_ValueChanged);
            this.scaleLowNumUpDown.ValueChanged += new EventHandler(scaleLowNumUpDown_ValueChanged);
            this.scaleHighNumUpDown.ValueChanged += new EventHandler(scaleHighNumUpDown_ValueChanged);
            this.out1NonInvRdb.CheckedChanged += new EventHandler(out1NonInvRdb_CheckedChanged);
            this.out1LowLimitNumUpDown.ValueChanged += new EventHandler(out1LowLimitNumUpDown_ValueChanged);
            this.out1HighLimitNumUpDown.ValueChanged += new EventHandler(out1HighLimitNumUpDown_ValueChanged);
            this.out1AdjNumUpDown.ValueChanged += new EventHandler(out1AdjNumUpDown_ValueChanged);
            this.out2NonInvRdb.CheckedChanged += new EventHandler(out2NonInvRdb_CheckedChanged);
            this.out2LowLimitNumUpDown.ValueChanged += new EventHandler(out2LowLimitNumUpDown_ValueChanged);
            this.out2HighLimitNumUpDown.ValueChanged += new EventHandler(out2HighLimitNumUpDown_ValueChanged);
            this.out2AdjNumUpDown.ValueChanged += new EventHandler(out2AdjNumUpDown_ValueChanged);
            this.slaveidNumUpDown.ValueChanged += new EventHandler(slaveidNumUpDown_ValueChanged);
            this.baudRateComboBox.SelectionChangeCommitted += new EventHandler(baudRateComboBox_SelectionChangeCommitted);
            this.stopBotComboBox.SelectionChangeCommitted += new EventHandler(stopBotComboBox_SelectionChangeCommitted);
            this.dataSizeComboBox.SelectionChangeCommitted += new EventHandler(dataSizeComboBox_SelectionChangeCommitted);
            this.parityBitComboBox.SelectionChangeCommitted += new EventHandler(parityBitComboBox_SelectionChangeCommitted);
            this.per10CheckBox.CheckedChanged += new EventHandler(per10CheckBox_CheckedChanged);
            _mbissent = false;
        }

        private void saveBtn_Click(object sender, EventArgs e)
        {
            selectedPara = new object[]
            {
                inputSelect,
                pvGainSelect,
                pvAdjSelect,
                pvFilSelect,
                cfSelect,
                slhSelect,
                sllSelect,
                out1InvSelect,
                out1HighLimitselect,
                out1LowLimitselect,
                out1AdjSelect,
                out2InvSelect,
                out2HighLimitselect,
                out2LowLimitselect,
                out2AdjSelect,
                swVer,
                setDefaultSelect,
                typeOptionSelect,
                output1TypeSelect,
                output2TypeSelect,
                baudRateSelect,
                dataSizeSelect,
                stopBitSelect,
                paritySelect,
                commuSelect,
                slaveIdSelect,
                per10EnableSelect,
                out1StatusSelect,
                out2StatusSelect
            };
            SaveFileDialog scf = new SaveFileDialog();
            scf.Filter = "binary files (*.bin)|*.bin|All files (*.*)|*.*";
            scf.InitialDirectory = @"C:\";
            scf.Title = "Please select location to save a config file.";
            scf.FileName = "*.bin";
            if (scf.ShowDialog() == DialogResult.OK)
            {
                if (Path.GetExtension(scf.FileName) != ".bin")
                {
                    MyMsgBox.Showmsg("Warning you're saving with wrong file type, this file can not be used for configuration. " +
                        "Please save it again with .bin type", "Wrong file type!", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                FileStream configfs = new FileStream(scf.FileName, FileMode.Create);
                BinaryWriter bw = new BinaryWriter(configfs);
                //-----write number to binary file-----//
                for (int i = 0; i < selectedPara.Length; i++ )
                {
                    bw.Write(Convert.ToInt32(selectedPara[i]));
                }
                bw.Close();
                configfs.Close();
                MyMsgBox.Showmsg("Saving config file is succeeded!", "Done!", MessageBoxButtons.OK, MessageBoxIcon.None);
                //MyMsgBox.Showmsg("Saving config file is succeed!", "Done");
            }
        }

        private void loadBtn_Click(object sender, EventArgs e)
        {
            OpenFileDialog configfile = new OpenFileDialog();
            configfile.Filter = "binary files (*.bin)|*.bin|All files (*.*)|*.*";
            configfile.InitialDirectory = @"C:\";
            configfile.Title = "Please select a config file.";
            //-----load setting value when select file-----//
            if (configfile.ShowDialog() == DialogResult.OK)
            {
                if (Path.GetExtension(configfile.FileName) == ".bin")
                {
                    DisableEvent();
                    Thread.Sleep(1000);
                    FileStream configreadfs = new FileStream(configfile.FileName, FileMode.Open, FileAccess.Read);
                    BinaryReader br = new BinaryReader(configreadfs);
                    //-----read number from binary file-----//  
                    inputSelect = (short)br.ReadInt32();
                    pvGainSelect = (short)br.ReadInt32();
                    pvAdjSelect = (short)br.ReadInt32();
                    pvFilSelect = (short)br.ReadInt32();
                    cfSelect = (short)br.ReadInt32();
                    slhSelect = br.ReadInt32();
                    sllSelect = br.ReadInt32();
                    out1InvSelect = (short)br.ReadInt32();
                    out1HighLimitselect = br.ReadInt32();
                    out1LowLimitselect = br.ReadInt32();
                    out1AdjSelect = br.ReadInt32();
                    out2InvSelect = (short)br.ReadInt32();
                    out2HighLimitselect = br.ReadInt32();
                    out2LowLimitselect = br.ReadInt32();
                    out2AdjSelect = br.ReadInt32();
                    swVer = (short)br.ReadInt32();
                    setDefaultSelect = (short)br.ReadInt32();
                    typeOptionSelect = (short)br.ReadInt32();
                    output1TypeSelect = (short)br.ReadInt32();
                    output2TypeSelect = (short)br.ReadInt32();
                    baudRateSelect = (short)br.ReadInt32();
                    dataSizeSelect = (short)br.ReadInt32();
                    stopBitSelect = (short)br.ReadInt32();
                    paritySelect = (short)br.ReadInt32();
                    commuSelect = (short)br.ReadInt32();
                    slaveIdSelect = (short)br.ReadInt32();
                    per10EnableSelect = (short)br.ReadInt32();
                    out1StatusSelect = (short)br.ReadInt32();
                    out2StatusSelect = (short)br.ReadInt32();
                    configreadfs.Close();
                    using (MsgBoxWaiting msg = new MsgBoxWaiting(loadProcess))
                    {
                        msg.ShowDialog(this);
                    }
                    EnableEvent();
                    if (Succeed)
                    {
                        MyMsgBox.Showmsg("Loading config file is succeeded!", "Done!", MessageBoxButtons.OK, MessageBoxIcon.None);
                    }
                    else
                    {
                        MyMsgBox.Showmsg("Can not load setting, Please try again", "Fail", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }                  
                    //threadstart();
                }
                else
                {
                    MyMsgBox.Showmsg("Wrong file type was selected, Please selecte again", "Wrong file type!", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }


        }

        private void loadProcess()
        {
            Succeed = ApplyChange(true);
            BeginInvoke(new delegate_updateUI(updateUI));
        }

        private void updateUI()
        {
            Thread.Sleep(500);
            mb.SendFc4(1, 0, mbNumber, ref mbReadValues);
            SetAllParameters(mbReadValues);
            ShowSettingParameter();
            ShowPVOutputParameter(mbReadValues);
            Thread.Sleep(200);
            if(Succeed == true) { applyBtn.Enabled = false; }
        }

        private void button8_Click(object sender, EventArgs e)
        {

                
        }


        private void out2StatusButton_Click(object sender, EventArgs e)
        {
            if (out2StatusSelect == 1)
            {
                out2StatusSelect = 0;
            }
            else
            {
                out2StatusSelect = 1;
            }
            EnableOutput(out2StatusButton, out2ValuePanel, out2CurrentSrcPanel,  out2StatusSelect);
            out2Status_change = true;
            applyBtn.Enabled = true;
        }

        private void out1StatusButton_Click(object sender, EventArgs e)
        {
            if (out1StatusSelect == 1)
            {
                out1StatusSelect = 0;
            }
            else
            {
                out1StatusSelect = 1;
            }
            EnableOutput(out1StatusButton, out1ValuePanel, out1CurrentSrcPanel, out1StatusSelect);
            out1Status_change = true;
            applyBtn.Enabled = true;
        }

        private void manualViewButton_Click(object sender, EventArgs e)
        {
            //UM__EM_N_L_LC_Series__F62_01
            //String openPDFFile = AppDomain.CurrentDomain.BaseDirectory + @"\" + "UM-[EM-N-L-LC-Series]-F62-01.pdf";
            //System.Diagnostics.Process.Start(openPDFFile);
            System.Diagnostics.Process.Start("http://www.pm.co.th/EM-N-Series/5cfa00a319ad380010fc2ded");
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            System.Diagnostics.Process.Start("https://www.primusthai.com");
           
        }
    }
}
